import { RabbitMqBroker } from 'ts-common/rabbitMq';
import { rabbitMq, redis } from './variables';
import { log } from './logger';
import { queryServiceReader, queryServiceReaderTest } from './readers/queryService';
import { insightProcessor } from './readers/insightProcessor';

async function main() {
  log.info('Starting query-service...');

  log.info('Connecting to RabbitMQ...');
  const frontendPublisher = await new RabbitMqBroker(rabbitMq, 'ui-direct-exchange').connect();
  const mlPublisher = await new RabbitMqBroker(
    rabbitMq,
    'ml-direct-exchange',
    'query-service',
    undefined,
    { autoDelete: false },
    { autoDelete: false },
  ).connect();
  log.info('Connected to RabbitMQ!');

  log.info('Connecting to Redis...');
  await redis.connect();
  log.info('Connected to Redis!');

  //queryServiceReader(frontendPublisher, mlPublisher, 'neo4j');
  insightProcessor();
  //queryServiceReader(frontendPublisher, mlPublisher, 'neo4j');

  // TODO: other query services for other databases
  //queryServiceReaderTest(frontendPublisher, mlPublisher, 'neo4j');

  log.info('Connected to RabbitMQ!');
}

main();
